﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;


using Infragistics.Web.UI.GridControls;


public partial class _Default : System.Web.UI.Page
{

    private ExhibitLR2DetalsDS DetailsDS = new ExhibitLR2DetalsDS(); 
    
    protected void Page_Load(object sender, EventArgs e)
    {

        //if (!IsPostBack)
        //{
            ExhibitLR2MasterDS MasterDS = new ExhibitLR2MasterDS();
            MasterDS.MasterTable.Rows.Add(new object[] { 1, "100000", "Description 01", 12, 15000 });
            MasterDS.MasterTable.Rows.Add(new object[] { 2, "200000", "Description 02", 14, 22000 });
            MasterDS.MasterTable.Rows.Add(new object[] { 3, "300000", "Description 03", 17, 14000 });
            MasterDS.MasterTable.Rows.Add(new object[] { 4, "400000", "Description 04", 22, 12000 });
            MasterDS.MasterTable.Rows.Add(new object[] { 5, "500000", "Description 05", 25, 650000 });
            MasterDS.MasterTable.Rows.Add(new object[] { 6, "600000", "Description 06", 45, 0 });
            MasterDS.MasterTable.Rows.Add(new object[] { 7, "700000", "Description 07", 65, 12555 });

            MasterDS.Dummy.Rows.Add(new object[] { 2, "dummy rec 2" });
            MasterDS.Dummy.Rows.Add(new object[] { 4, "dummy rec 4" });
            MasterDS.Dummy.Rows.Add(new object[] { 5, "dummy rec 5" });
            MasterDS.Dummy.Rows.Add(new object[] { 7, "dummy rec7" });

            DetailsDS.type3tbl.Addtype3tblRow(1, 2, 0, "Description01 m2", 230, 0, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(2, 2, 0, "Description02 m2", 1500, 1, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(3, 2, 0, "Description03 m2", 1250, 0, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(4, 2, 0, "Description04 m2", 12, 1, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(5, 2, 0, "Description05 m2", 0, 0, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(6, 2, 0, "Description06 m2", 350, 1, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(7, 2, 0, "Description07 m2", 1800, 1, true, true);


            DetailsDS.type3tbl.Addtype3tblRow(8, 4, 0, "Description01 m4", 230, 0, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(9, 4, 0, "Description02 m4", 1500, 1, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(10, 4, 0, "Description03 m4", 1250, 0, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(11, 4, 0, "Description04 m4", 12, 1, true, true);


            DetailsDS.type3tbl.Addtype3tblRow(12, 5, 0, "Description05 m5", 0, 1, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(13, 5, 0, "Description06 m5", 350, 0, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(14, 5, 0, "Description07 m5", 1800, 1, true, true);


            DetailsDS.type3tbl.Addtype3tblRow(15, 7, 0, "Description01 m7", 230, 1, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(16, 7, 0, "Description02 m7", 1500, 1, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(17, 7, 0, "Description03 m7", 1250, 0, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(18, 7, 0, "Description04 m7", 12, 1, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(19, 7, 0, "Description05 m7", 0, 1, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(20, 7, 0, "Description06 m7", 350, 0, true, true);
            DetailsDS.type3tbl.Addtype3tblRow(21, 7, 0, "Description07 m7", 1800, 1, true, true);

            whdg.DataSource = MasterDS;
            whdg.DataBind();
        //}
    }


    protected void whdg_RowIslandsPopulating(object sender, Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs e)
    {
        e.Cancel = true;
        ContainerGrid IslandGrid = new ContainerGrid();

        int iMaster = System.Convert.ToInt32(e.Row.Items[0].Value);

        ExhibitLR2DetalsDS.type3tblDataTable islandType3Tbl = DetailsDS.type3tbl;
        islandType3Tbl.DefaultView.RowFilter = "idMaster = " + iMaster.ToString();


        e.Row.RowIslands.Add(IslandGrid);        
        IslandGrid.AutoGenerateColumns = false;
       // IslandGrid.CalculateCustomSummary += new CalculateCustomSummaryHandler(IslandGrid_CalculateCustomSummary);
      

        IslandGrid.Behaviors.CreateBehavior<EditingCore>();
        IslandGrid.Behaviors.EditingCore.Behaviors.CreateBehavior<CellEditing>();
        IslandGrid.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.MouseClick = EditMouseClickAction.Single;

        IslandGrid.Behaviors.CreateBehavior<Activation>();
        //IslandGrid.Behaviors.Activation.AutoPostBackFlags = true;



        BoundDataField ridCol = new BoundDataField();
        ridCol.DataFieldName = "idRec";
        ridCol.Header.Text = "idRec";
        ridCol.Key = "idRec";

        BoundDataField midCol2 = new BoundDataField();
        midCol2.DataFieldName = "idMaster";
        midCol2.Header.Text = "idMaster";
        midCol2.Key = "idMaster";

        BoundDataField iddtCol = new BoundDataField();
        iddtCol.DataFieldName = "idLR5Detail";
        iddtCol.Header.Text = "idLR5Detail";
        iddtCol.Key = "idLR5Detail";

        BoundDataField DescCol = new BoundDataField();
        DescCol.DataFieldName = "Description";
        DescCol.Header.Text = "Description";
        DescCol.Key = "Description";

        BoundDataField amtCol = new BoundDataField();
        amtCol.DataFieldName = "Amount";
        amtCol.Header.Text = "Amount";
        amtCol.Key = "Amount";

        BoundDataField ntypeCol = new BoundDataField();
        ntypeCol.DataFieldName = "NType";
        ntypeCol.Header.Text = "NType";
        ntypeCol.Key = "NType";

        BoundDataField ronlyCol = new BoundDataField();
        ronlyCol.DataFieldName = "ReadOnly";
        ronlyCol.Header.Text = "ReadOnly";
        ronlyCol.Key = "ReadOnly";

        BoundDataField deCol = new BoundDataField();
        deCol.DataFieldName = "DescEditable";
        deCol.Header.Text = "DescEditable";
        deCol.Key = "DescEditable";




        IslandGrid.Columns.Add(ridCol);
        IslandGrid.Columns.Add(midCol2);
        IslandGrid.Columns.Add(iddtCol);
        IslandGrid.Columns.Add(DescCol);
        IslandGrid.Columns.Add(amtCol);
        IslandGrid.Columns.Add(ntypeCol);
        IslandGrid.Columns.Add(ronlyCol);
        IslandGrid.Columns.Add(deCol);


        //IslandGrid.Columns["ReadOnly"].Hidden = true;
        //IslandGrid.Columns["idRec"].Hidden = true;
        //IslandGrid.Columns["idMaster"].Hidden = true;
        //IslandGrid.Columns["idLR5Detail"].Hidden = true;

        IslandGrid.Key = "idRec";
        IslandGrid.DataKeyFields = "idRec";



        // type 3 custom summary setting :

        
        IslandGrid.Behaviors.CreateBehavior<SummaryRow>();
        //SummaryRowSetting Sum3Amount = new SummaryRowSetting(IslandGrid, "Amount");
        //SummarySetting type3CustSummary = new SummarySetting();
        //type3CustSummary.SummaryType = SummaryType.Custom;
        //type3CustSummary.CustomSummaryName = "TYPE3CLOBAL";
        //type3CustSummary.FormatString = "Closing Balance:  {1}";
        //Sum3Amount.SummarySettings.Add(type3CustSummary);
        //IslandGrid.Behaviors.SummaryRow.ColumnSettings.Add(Sum3Amount);

        IslandGrid.Behaviors.SummaryRow.FormatString = "Closing balance: ${1}";
        IslandGrid.Behaviors.SummaryRow.ShowSummariesButtons = false;
        IslandGrid.Behaviors.SummaryRow.SummariesCssClass = "Summary01";

        ColumnSummaryInfo type3Info = new ColumnSummaryInfo();
        type3Info.ColumnKey = "Amount";
        Summary type3Summary = new Summary();
        type3Summary.SummaryType = SummaryType.Custom;
        type3Summary.CustomSummaryName = "TYPE3";
        type3Info.Summaries.Add(type3Summary);
        IslandGrid.Behaviors.SummaryRow.ColumnSummaries.Add(type3Info);

       





        IslandGrid.DataSource = islandType3Tbl;
        IslandGrid.DataBind();

    }

  
    protected object IslandGrid_CalculateCustomSummary(object sender, CustomSummaryEventArgs e)
    {
        string a = e.Summary.CustomSummaryName;
        ContainerGrid IslandGridLoc = (ContainerGrid)sender;
        //Trace.Warn("CalculateCustomSummary"); 
        int sum = 0;
        int fact = 1;
        foreach (GridRecord gr in IslandGridLoc.Rows)
        {
            fact = ((int)gr.Items[5].Value ==1 ) ? 1:-1; 
            sum += (int)gr.Items[4].Value * fact;
        }
       
        return sum;
    
          //if (e.Summary.CustomSummaryName == "TYPE3")
          //{
          //    int sum = 0;
          //    foreach ( GridRecord rec in this.IslandGrid.
          //}


    }

    





    protected object whdg_CalculateCustomSummary1(object sender, CustomSummaryEventArgs e)
    {
        
        string a = e.Summary.CustomSummaryName;
        ContainerGrid IslandGridLoc = (ContainerGrid)sender;
        if (IslandGridLoc.DataKeyFields != whdg.Bands[0].DataKeyFields)
        {
            //Parent
            //Trace.Warn("CalculateCustomSummary"); 
            int sum = 0;
            int fact = 1;
            foreach (GridRecord gr in IslandGridLoc.Rows)
            {
                fact = ((int)gr.Items[5].Value == 1) ? 1 : -1;
                sum += (int)gr.Items[4].Value * fact;
            }

            return sum;
        }
        else
        {

            return 0;
        }
    }
    protected void whdg_RowUpdating(object sender, RowUpdatingEventArgs e)
    {
        
    }
}